#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <memory.h>
#include <process.h>
#include <alloc.h>
#include <io.h>

#ifdef __DPMI16__

void PrintStr (char *s, int mode)
{
  char *p = s;
  char c;
  while (*p)
  {
    c = *p;
    _DL = c;
    _AH = 0x02;
    geninterrupt (0x21);
    p++;
  }

  if (mode == 1)
  {
    _DL = 10;
    _AH = 0x02;
    geninterrupt (0x21);

    _DL = 13;
    _AH = 0x02;
    geninterrupt (0x21);
  }
  else
  if (mode == 2)
  {
    _DL = 0x20;
    _AH = 0x02;
    geninterrupt (0x21);
  }
}

char ToHexAscii (char c)
{
  if (c < 0x0A)
    return c | 0x30;

  return 'A'+ (c - 0x0A);
}

void PrintByte (unsigned char num, int mode)
{
  char str[3];
  char un = num >> 4;
  char ln = num & 0x0F;

  str[0] = ToHexAscii (un);
  str[1] = ToHexAscii (ln);
  str[2] = 0;

  PrintStr (str, mode);
}

void PrintNum (unsigned short num, int mode)
{
  PrintByte ((num>>8), 0);
  PrintByte ((num & 0x00FF), mode);
}

void __pascal __export BigError (void)
{
  printf ("\nNon fixed-up function called.\n");
  exit (-1);
}

#pragma argsused
WORD __pascal _export BUEH_SetErrorMode (WORD wFlags)
{
//  printf ("\nSetErrorMode\n");
  return 0;  // fail the function
}

#pragma argsused
void __pascal _export BUEH_FatalAppExit (unsigned short a, char *s)
{
  printf ("\nFATALAPPEXIT: %s\n", s);
  exit (-1);
}

#pragma argsused
WORD __pascal _export BUEH_WNetGetCaps (WORD w)
{
  printf ("\nWNetGetCaps: %04X\n", w);
  if (w == 0x0002)
    return 0xFFFF;
  return 0;  // always return 0
}

#pragma argsused
WORD __pascal _export BUEH_WNetGetConnection (char *local, char *remote, WORD nbuf)
{
  printf ("\nWNetGetConnection: %s\n", local);
  return WN_NOT_CONNECTED;
}

#pragma argsused
WORD __pascal _export BUEH_WNetGetUser (char *user, WORD *nbuf)
{
  printf ("\nWNetGetUser: ");
  if (!nbuf)
    return WN_BAD_POINTER;

  printf ("nbuf:%d", *nbuf);
  strcpy (user, "UserName");
  printf (" %s\n", user);
  return WN_SUCCESS;
}

#define ATOMMAX    0x3F00
#define ATOMMASK   0xC000
char far * far AtomArray[ATOMMAX];

static WORD FindFirstFreeAtom (void)
{
  WORD x;

  for (x = 0;x < ATOMMAX; x++)
  {
    if (AtomArray[x] == 0)
      return x;
  }
  return 0xFFFF;
}
ATOM __pascal _export BUEH_GlobalAddAtom (char *str)
{
  WORD x;

  printf ("\nGlobalAddAtom: %s ", str);

  x = FindFirstFreeAtom ();
  if (x == 0xFFFF)
    return 0;

  AtomArray[x] = strdup (str);

  printf ("%04X\n", x);
  return x+ATOMMASK;
}

ATOM __pascal _export BUEH_GlobalDeleteAtom (ATOM a)
{
  WORD x = a - ATOMMASK;

  printf ("\nGlobalDeleteAtom %04X\n", x);
  if (x > ATOMMAX)
    return a;

  if (!AtomArray[x])
    return a;

  free (AtomArray[x]);
  AtomArray[x] = 0;
  return 0;
}

ATOM __pascal _export BUEH_GlobalFindAtom (char *str)
{
  WORD x;

  printf ("\nGlobalFindAtom: %s ", str);

  for (x=0;x<ATOMMAX;x++)
  {
    if (AtomArray[x])
      if (strcmp (AtomArray[x], str) == 0)
      {
        printf ("Found: %04X\n", x);
        return x+ATOMMASK;
      }
  }
  printf ("Not found\n");
  return 0;
}

WORD __pascal _export BUEH_GetCurrentPDB (void)
{
  return _psp;
}

int __pascal _export BUEH_GetTempFileName (unsigned char drive, char *prefix, WORD uniq, char *dest)
{
  char windir[100];
  WORD cnt = 0;
  drive = drive & 0x7F;
  if (drive == 0)
    drive = 'C';

  GetWindowsDirectory (windir, 100);
  if (windir[strlen(windir)-1] != '\\')
    strcat (windir, "\\");
  printf ("GetTempFileName: windir:%s", windir);
  do
  {
    sprintf (dest, "%s%s%04X.TMP", windir, prefix, uniq+cnt);
    cnt++;
    printf ("\n  Trying...%s", dest);
  } while (access (dest, 0) == 0);

  printf ("\n  Unique %04X\n", uniq+cnt-1U );
  return uniq+cnt-1U;
}

#pragma argsused
void * __pascal _export BorlandUnresolvedEntryHook (char *modname, int isOrd, char *Entry)
{
  int ord = 0;
  if (isOrd)
    ord = FP_OFF (Entry);

  if (isOrd)
  {
    switch (FP_OFF (Entry))
    {
      case  37:  return BUEH_GetCurrentPDB;
      case  97:  return BUEH_GetTempFileName;
      case 107:  return BUEH_SetErrorMode;
      case 137:  return BUEH_FatalAppExit;
      case 268:  return BUEH_GlobalAddAtom;
      case 269:  return BUEH_GlobalDeleteAtom;
      case 270:  return BUEH_GlobalFindAtom;
      case 512:  return BUEH_WNetGetConnection;
      case 513:  return BUEH_WNetGetCaps;
      case 516:  return BUEH_WNetGetUser;
    }
  }

  PrintStr (modname, 2);
  if (isOrd)
    PrintNum (ord, 1);
  else
    PrintStr (Entry, 1);

  return BigError;
}

#endif

